﻿
Public Class Form1
    Dim WithEvents HorzScroll As New HScrollBar 'объект - горизонтальный скролбар
    Dim WithEvents VertScroll As New VScrollBar 'объект - вертикальный скролбар
    Dim BuferBitmap As Drawing.Bitmap   'объект - внеэкранный битмап
    Dim BuferGraphics As Drawing.Graphics 'объект - Graphics, внеэкранного битмапа(на нем будем рисовать)  
    Dim sourceRectangle As Rectangle ' прямоугольная область для копирования из буфера на форму 
    Dim destRectangle As Rectangle ' вторая область в принципе не нужна, но если мы будем масштабировать вывод, то може пригодиться
    Dim szClientSize As Size 'для хранения размеров клиентской области формы
    Dim szScreenSize As Size 'для хранения размеров экрана и внеэкранного битмапа
    Dim dX As Int32 = 0 'переменная для хранения смещения горизонтального скроллбара
    Dim dY As Int32 = 0 'переменная для хранения смещения вертикального скроллбара

    Private Sub Form1_FormClosed(sender As Object, e As FormClosedEventArgs) Handles Me.FormClosed
        'при закрытии формы, "убиваем" все объекты, которые мы насоздавали
        BuferBitmap.Dispose()
        BuferGraphics.Dispose()
        HorzScroll.Dispose()
        VertScroll.Dispose()
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        'объявляем горизонтальный и вертикальный скроллбары и частично инициализируем их позиции и размеры
        HorzScroll = New HScrollBar With {.Left = 0, .Height = 16}
        VertScroll = New VScrollBar With {.Top = 0, .Width = 16}
        AddHandler HorzScroll.Scroll, AddressOf ScrollBar_Scroll 'указываем процедуры, которые будут выполняться при работе горизонтального
        AddHandler VertScroll.Scroll, AddressOf ScrollBar_Scroll 'и вертикального скролбара
        Me.Controls.Add(HorzScroll) 'добавляем на форму горизонтальный
        Me.Controls.Add(VertScroll) 'и вертикальный скроллбары
        szScreenSize = Screen.PrimaryScreen.Bounds.Size 'получаем размеры экрана; они понадобятся для создания внеэкранного битмапа; в принципе можно этого не делать,
        ' а создать битмап любого размера
        BuferBitmap = New Drawing.Bitmap(szScreenSize.Width, szScreenSize.Height) 'создаём внеэкранный битмап размером с экран
        BuferGraphics = Graphics.FromImage(BuferBitmap) 'создаём объект Graphics, связанный с нашим внеэкранным битмапом
        PaintOnBitmap() 'вызываем функцию, которая рисует на внеэкранном битмапе 
        Me.OnResize(e) 'принудительно вызываем функцию "Form1_Resize"; она нам нужна, для окончательной инициации параметров скроллбаров
    End Sub

    Private Sub Form1_Paint(sender As Object, e As PaintEventArgs) Handles Me.Paint
        'Копирует заданную область рисунка, из буфера на форму, без изменения масштаба. Если изменить размер целевой области, то изображение будет масштабировано
        e.Graphics.DrawImage(BuferBitmap, destRectangle, sourceRectangle, GraphicsUnit.Pixel)
    End Sub

    Private Sub Form1_Resize(sender As Object, e As EventArgs) Handles Me.Resize
        szClientSize.Width = Me.ClientSize.Width - 16 'сохраняем новый размер клиентской
        szClientSize.Height = Me.ClientSize.Height - 16 'области в нашей структуре
        sourceRectangle = New Rectangle(dX, dY, szClientSize.Width, szClientSize.Height) 'в этом прямоугольнике будет содержаться исходная область для копирования,
        destRectangle = New Rectangle(0, 0, szClientSize.Width, szClientSize.Height) ' а в этом - целевая область(в которую будем вставлять изображение из внеэкранного битмапа)
        If dX > szScreenSize.Width - szClientSize.Width + 1 Then 'обработка положения ползунка горизонтального скролбара
            dX = szScreenSize.Width - szClientSize.Width + 1
            HorzScroll.Value = dX
        End If
        If dY > szScreenSize.Height - szClientSize.Height + 1 Then 'обработка положения ползунка вертикального скролбара
            dY = szScreenSize.Height - szClientSize.Height + 1
            VertScroll.Value = dY
        End If
        'далее пересчитываем положения скроллбаров и некоторые их параметры(.Maximum, .LargeChange, .SmallChange)
        HorzScroll.Width = szClientSize.Width
        HorzScroll.Top = szClientSize.Height
        HorzScroll.Maximum = szScreenSize.Width
        HorzScroll.LargeChange = szClientSize.Width
        HorzScroll.SmallChange = HorzScroll.Maximum / 100
        VertScroll.Left = szClientSize.Width
        VertScroll.Height = szClientSize.Height
        VertScroll.Maximum = szScreenSize.Height
        VertScroll.LargeChange = szClientSize.Height
        VertScroll.SmallChange = VertScroll.Maximum / 100
        Me.Refresh() '...и вызываем перерисовку формы (принудительно вызываем функцию "Form1_Paint")
    End Sub

    Private Sub ScrollBar_Scroll(ByVal sender As Object, ByVal e As ScrollEventArgs)
        If e.NewValue = e.OldValue Then Exit Sub
        If e.ScrollOrientation = ScrollOrientation.HorizontalScroll Then 'функция обрабатывает положение обоих скроллбаров, поэтому выясняем
            dX = e.NewValue 'если сработал горизонтальный, то меняем dX
        Else
            dY = e.NewValue 'если вертикальный, то dY
        End If
        sourceRectangle = New Rectangle(dX, dY, szClientSize.Width, szClientSize.Height) ' пересчитываем координаты области из которой мы будем копировать изображение 
        Me.Refresh() '...и вызываем перерисовку формы (принудительно вызываем функцию "Form1_Paint")
    End Sub

    Private Sub PaintOnBitmap() 'тут можно рисовать всё, что хочешь; ограничения только по размеру области заданной структурой "szScreenSize"
        Dim myPen1 As New System.Drawing.Pen(Color.Red, 1) 'создаём объект - перо, которым будем рисовать в буфере; если рисунок будет сложным, 
        Dim myPen2 As New System.Drawing.Pen(Color.Blue, 1) 'то можно сразу создать несколько перьев, кистей, шрифтов и т.д.
        Dim myColor1 As Color = Color.FromArgb(50, Color.Magenta)
        Dim myBrush1 As SolidBrush = New SolidBrush(myColor1)
        Dim myColor2 As Color = Color.White
        Dim rt As Rectangle
        rt.Y = 0
        rt.X = 0
        rt.Height = szScreenSize.Height
        rt.Width = szScreenSize.Width / 2
        BuferGraphics.FillRectangle(New SolidBrush(myColor2), rt)

        BuferGraphics.DrawRectangle(myPen1, 0, 0, szScreenSize.Width - 1, szScreenSize.Height - 1)
        BuferGraphics.DrawLine(myPen2, 0, 0, szScreenSize.Width - 1, szScreenSize.Height - 1)
        BuferGraphics.DrawLine(myPen2, 0, szScreenSize.Height - 1, szScreenSize.Width - 1, 0)
        BuferGraphics.DrawEllipse(myPen1, Convert.ToInt32(szScreenSize.Width / 5), Convert.ToInt32(szScreenSize.Height / 5), Convert.ToInt32(szScreenSize.Width * 3 / 5), Convert.ToInt32(szScreenSize.Height * 3 / 5))
        BuferGraphics.DrawEllipse(myPen1, Convert.ToInt32(szScreenSize.Width / 3), Convert.ToInt32(szScreenSize.Height / 3), Convert.ToInt32(szScreenSize.Width / 3), Convert.ToInt32(szScreenSize.Height / 3))
        rt.Y = szScreenSize.Height / 3
        rt.Height = szScreenSize.Height / 3
        rt.Width = 80
        For x = 0 To szScreenSize.Width Step 100
            rt.X = x
            BuferGraphics.FillRectangle(myBrush1, rt)
        Next
        myBrush1.Dispose()
        myPen1.Dispose()
        myPen2.Dispose()
    End Sub
End Class
